<template>
  <div class="auth">
    <div class="auth-wrap">
      <div class="auth-head">
        <img src="../assets/img/auth/logo.png" alt="">
      </div>
      <v-list-item-title v-if="error" class="text-center my-2 auth-error">
        Неверный логин или пароль
        <v-divider class="mt-1"/>
      </v-list-item-title>
      <v-form v-model="validate">
        <div class="auth-form">
          <div class="input-container">
            <v-text-field
              v-model="username"
              label="Логин"
              placeholder="Введите логин"
              :rules="[rules.required, rules.length]"
              @keyup.enter="login"
            ></v-text-field>
          </div>
          <div class="input-container">
            <v-text-field
              v-model="password"
              label="Пароль"
              placeholder="Введите пароль"
              :rules="[rules.required, rules.length]"
              :type="show ? 'text' : 'password'"
              :append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
              @keyup.enter="login"
              @click:append="show = !show"
            ></v-text-field>
          </div>
        </div>
      </v-form>
      <v-btn
        color="primary"
        elevation="2"
        raised
        class="ml-auto d-flex mr-6 mb-6"
        :disabled="!validate"
        @click="login"
      >
        Продолжить
      </v-btn>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import router from '@/router'
export default {
  name: 'Auth',
  data: () => ({
    username: "",
    password: "",
    rules: {
      required: v => !!v || 'Это поле обязательно к заполнению',
      length: (value) => (value && value.length >= 3) || "Минимальная длина 3 символа"
    },
    validate: false,
    show: false,
    error: false
  }),
  computed: {
    ...mapGetters([
      'ERROR'
    ]),
    isAuth() {
      return this.ERROR && this.ERROR.length
    }
  },
  watch: {
    username() {
      this.error = false
    },
    password() {
      this.error = false
    }
  },
  methods: {
    ...mapActions([
      'LOGIN'
    ]),
    login() {
      const data = {username: this.username, password: this.password}
      this.$store.dispatch('LOGIN', data)
        .then(()=>{
          this.$router.replace({name: 'Deal'}) // хочу отправить пользовталея на страницу
        })
        .catch(()=>(this.error = true))
    }
  }
}
</script>

<style scoped lang="scss">
  .auth {
    width: 100vw;
    height: 100vh;
    background: url("../assets/img/auth/bg-auth.jpg") center no-repeat;
    background-size: cover;
    position: relative;
    .auth-wrap {
      width: 350px;
      padding-bottom: 5px;
      background: #FFFFFF;
      box-shadow: 0px 12px 32px rgba(0, 0, 0, 0.25);
      border-radius: 8px;
      position: fixed;
      top: calc(50vh - 202px);
      right: 100px;
      @media (max-width: 550px) {
        right: calc(50% - 175px);
      }
      .auth-error {
        position: absolute;
        font-weight: bold;
        color: red;
        left: 50%;
        transform: translate(-50%, 10%);
      }
      .auth-head {
        display: flex;
        justify-content: center;
        align-items: center;
        padding: 26px;
        background: rgba(0, 0, 0, 0.04);
      }
      .auth-form {
        padding: 26px;
        .input-container {
          margin-bottom: 30px;
          p {
            margin-bottom: 5px;
          }
          input {
            background: #FFFFFF;
            box-shadow: inset 0px -1px 0px rgba(0, 0, 0, 0.12);
            width: 100%;
            padding: 10px 10px 10px 0;
          }
          input:focus {
            background: #FFFFFF;
            box-shadow: inset 0px -1px 0px #1976D2;
          }
        }
      }
    }
  }
</style>
